import { Type } from './Type';
export declare enum TypeState {
    anonymous = 0,
    exported = 1,
}
export declare class Namespace {
    constructor(id: number, name: string, short: string);
    addRef(shortName: string, namespace: Namespace): void;
    getShortRef(id: number): string;
    getUsedImportTbl(): {
        [short: string]: Namespace;
    };
    getUsedImportList(): Namespace[];
    addType(type: Type): void;
    exportType(type: Type): void;
    static register(id: number, name: string, short: string): Namespace;
    id: number;
    name: string;
    cachePath: string;
    /** Invisible document element defining the types of XML file root elements. */
    doc: Type;
    /** All types used in the document. */
    typeList: Type[];
    typeStateList: TypeState[];
    /** List of URL addresses of files with definitions for this namespace. */
    sourceList: string[];
    exported: boolean;
    private refList;
    private refTbl;
    private cacheDir;
    /** Example short name for this namespace, currently used only for elements
      * or attributes referenced from another namespace where they are defined. */
    short: string;
    /** Short names used to reference other namespaces in schemas defining this namespace. */
    shortNameTbl: {
        [namespaceId: string]: string[];
    };
    /** Table of namespaces actually imported, by short name. */
    private importTbl;
    /** List of referenced type names from each imported namespace. */
    importTypeNameTbl: {
        [namespaceId: string]: {
            [name: string]: Type;
        };
    };
    /** True only for the special namespace containing primitives. */
    isPrimitiveSpace: boolean;
    /** Internal list of namespaces indexed by a surrogate key. */
    private static list;
}
