import { Namespace } from './Namespace';
import { Member } from './Member';
export declare class Type {
    constructor();
    buildMemberTbl(): void;
    name: string;
    namespace: Namespace;
    safeName: string;
    bytePos: number;
    /** Primitive type, if the XML type only contains single value
      * that can be parsed into a JavaScript value. */
    literalType: Type;
    /** List of allowed literal values, if such a restriction is defined. */
    primitiveList: string[];
    attributeTbl: {
        [name: string]: Member;
    };
    childTbl: {
        [name: string]: Member;
    };
    /** XML attributes in an element of this type. */
    attributeList: Member[];
    /** Allowed child elements for an element of this type. */
    childList: Member[];
    /** Parent type this is derived from. */
    parent: Type;
    /** For an anonymous type, the member (of another type) that it defines.
      * Used for giving the type a descriptive name. */
    containingType: Type;
    containingMember: Member;
    comment: string;
    surrogateKey: number;
    private static nextKey;
    static optionalFlag: number;
    static arrayFlag: number;
}
