// This file is part of cxsd, copyright (c) 2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
var Type = (function () {
    function Type() {
        this.attributeTbl = {};
        this.childTbl = {};
        this.surrogateKey = Type.nextKey++;
    }
    // TODO: handle naming collisions between attributes and children,
    // and between namespaces.
    Type.prototype.buildMemberTbl = function () {
        var member;
        if (this.attributeList)
            for (var _i = 0, _a = this.attributeList; _i < _a.length; _i++) {
                member = _a[_i];
                this.attributeTbl[member.name] = member;
            }
        if (this.childList)
            for (var _b = 0, _c = this.childList; _b < _c.length; _b++) {
                member = _c[_b];
                this.childTbl[member.name] = member;
            }
    };
    Type.nextKey = 0;
    Type.optionalFlag = 1;
    Type.arrayFlag = 2;
    return Type;
}());
exports.Type = Type;
