// This file is part of cxsd, copyright (c) 2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Transform_1 = require('./Transform');
var AddImports = (function (_super) {
    __extends(AddImports, _super);
    function AddImports() {
        _super.apply(this, arguments);
        this.construct = AddImports;
    }
    AddImports.prototype.prepare = function () {
        this.visitType(this.doc);
        for (var _i = 0, _a = this.namespace.typeList; _i < _a.length; _i++) {
            var type = _a[_i];
            if (type)
                this.visitType(type);
        }
        return (true);
    };
    AddImports.prototype.visitType = function (type) {
        var member;
        // Types holding primitives should inherit from them.
        // NOTE: This makes base primitive types inherit themselves.
        if (type.literalType && !type.parent)
            type.parent = type.literalType;
        if (type.parent)
            this.visitTypeRef(type.parent);
        for (var _i = 0, _a = this.getTypeMembers(type); _i < _a.length; _i++) {
            var member = _a[_i];
            for (var _b = 0, _c = member.typeList; _b < _c.length; _b++) {
                var memberType = _c[_b];
                this.visitTypeRef(memberType, member);
            }
        }
    };
    AddImports.prototype.visitTypeRef = function (type, member) {
        if (type.namespace && type.namespace != this.namespace) {
            // Type from another, imported namespace.
            var id = type.namespace.id;
            var short = this.namespace.getShortRef(id);
            if (!short) {
                short = (member && member.namespace.getShortRef(id)) || type.namespace.short;
                if (short)
                    this.namespace.addRef(short, type.namespace);
            }
        }
    };
    return AddImports;
}(Transform_1.Transform));
exports.AddImports = AddImports;
