// This file is part of cxsd, copyright (c) 2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Transform_1 = require('./Transform');
function sanitizeName(name) {
    return (name.replace(/[^_0-9A-Za-z]/g, '').replace(/^[^A-Za-z]+/, ''));
}
var ListImports = (function (_super) {
    __extends(ListImports, _super);
    function ListImports() {
        _super.apply(this, arguments);
        this.construct = ListImports;
        this.output = {};
    }
    ListImports.prototype.prepare = function () {
        this.visitType(this.doc);
        for (var _i = 0, _a = this.namespace.typeList; _i < _a.length; _i++) {
            var type = _a[_i];
            if (type)
                this.visitType(type);
        }
        this.namespace.importTypeNameTbl = this.output;
        return (true);
    };
    ListImports.prototype.visitType = function (type) {
        if (type.parent)
            this.visitTypeRef(type.parent);
        for (var _i = 0, _a = this.getTypeMembers(type); _i < _a.length; _i++) {
            var member = _a[_i];
            for (var _b = 0, _c = member.typeList; _b < _c.length; _b++) {
                var memberType = _c[_b];
                this.visitTypeRef(memberType);
            }
        }
    };
    ListImports.prototype.visitTypeRef = function (type) {
        if (type.namespace && type.namespace != this.namespace) {
            // Type from another, imported namespace.
            // Make sure it gets exported.
            type.namespace.exportType(type);
            var id = type.namespace.id;
            var short = this.namespace.getShortRef(id);
            if (short) {
                if (!this.output[id])
                    this.output[id] = {};
                this.output[id][type.safeName] = type;
            }
        }
    };
    return ListImports;
}(Transform_1.Transform));
exports.ListImports = ListImports;
