import * as Promise from 'bluebird';
import { Namespace } from '../Namespace';
import { Type } from '../Type';
import { Member } from '../Member';
/** TransformType is a class derived from Transform, used like CRTP in C++. */
export declare abstract class Transform<TransformType, Output, State> {
    constructor(doc: Type);
    getTypeMembers(type: Type): Member[];
    prepare(): boolean | Promise<any>;
    exec(visitedNamespaceTbl?: {
        [key: string]: Namespace;
    }, state?: any): Promise<TransformType>;
    construct: {
        new (...args: any[]): Transform<TransformType, Output, State>;
    };
    protected doc: Type;
    protected namespace: Namespace;
    protected state: State;
}
