import * as Promise from 'bluebird';
import { FetchOptions } from 'cget';
import { Namespace } from './Namespace';
import { Source } from './Source';
/** Loader handles caching schema definitions and calling parser stages. */
export declare class Loader {
    constructor(options?: FetchOptions);
    import(urlRemote: string): Promise<Namespace>;
    /** Internal function called by Namespace.importSchema. */
    importFile(namespace: Namespace, urlRemote: string): Source;
    private finish();
    getOptions(): FetchOptions;
    private static cache;
    private static sourceTbl;
    private options;
    private parser;
    private targetNamespace;
    private pendingCount;
    private resolve;
    private reject;
}
