import * as types from './types';
import { Namespace } from './Namespace';
import { QName } from './QName';
export interface TypeMember {
    min: number;
    max: number;
    item: any;
}
/** Scope handles looking up references by type and name, and binding member
  * types and elements to types or namespaces. */
export declare class Scope {
    constructor(parent: Scope, namespace?: Namespace);
    private addString(name, type, target, min, max);
    add(name: QName, type: string, target: any, min: number, max: number): void;
    addToParent(name: QName, type: string, target: any, min: number, max: number): void;
    addAllToParent(type: string, min?: number, max?: number, target?: Scope): void;
    addComments(commentList: string[]): void;
    addCommentsToGrandParent(commentList: string[]): void;
    getComments(): string;
    lookup(name: QName, type: string): any;
    setType(type: types.TypeBase): void;
    setParentType(type: types.TypeBase): void;
    getParentType(namespace: Namespace): types.TypeBase;
    getType(): types.TypeBase;
    dumpTypes(): {
        [name: string]: TypeMember;
    };
    dumpElements(): {
        [name: string]: TypeMember;
    };
    dumpAttributes(): {
        [name: string]: TypeMember;
    };
    hasAttributes(): boolean;
    private parent;
    namespace: Namespace;
    private visible;
    private expose;
    private type;
    private commentList;
    private static primitiveScope;
}
