// This file is part of cxsd, copyright (c) 2015-2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var QName_1 = require('../QName');
var types = require('../types');
var MemberBase = (function (_super) {
    __extends(MemberBase, _super);
    function MemberBase() {
        _super.apply(this, arguments);
        this.id = null;
        this.name = null;
        this.ref = null;
        this.type = null;
    }
    MemberBase.prototype.resolveMember = function (state, kind) {
        var member = this;
        if (this.ref) {
            // Replace this with another, referenced element.
            var ref = new QName_1.QName(this.ref, state.source);
            member = this.scope.lookup(ref, kind);
            if (member)
                member.define(state, kind, this.min, this.max, this.scope);
            else
                throw new types.MissingReferenceError(this, state, kind, ref);
        }
        // If the element has a type set through an attribute, look it up in scope.
        if (this.type) {
            var type = new QName_1.QName(this.type, state.source);
            this.type = this.scope.lookup(type, 'type') || type;
        }
        else {
            // If there's a single type as a child, use it as the element's type.
            this.type = this.scope.getType();
        }
        return (member);
    };
    MemberBase.prototype.getTypes = function () {
        var typeList;
        // Filter out types of unresolved elements.
        if (typeof (this.type) == 'object' &&
            this.type instanceof types.TypeBase) {
            typeList = [this.type];
        }
        else
            typeList = [];
        return (typeList);
    };
    return MemberBase;
}(types.Base));
exports.MemberBase = MemberBase;
